using System;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.XR;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using Object = UnityEngine.Object;
using System.Text.RegularExpressions;

namespace Cotyounoyume
{
    public class Hint : MonoBehaviour 
    {
		public Atom atom;
		public EBATCore core;
		
		public Hint(EBATCore core){
			atom = core.atom;
			this.core = core;
		}
		
		public void loadSettings(){
			try{
			}catch (Exception e){
				core.loggerE(e);
			}
		}
		
		public void applySettings(){
		}
		
		public void VersionCheckHint(){
			string message = 
				"<b><size=48>The version-up adds new parameters to this plugin.</size></b>\n" + 
				"The existing parameters will not be changed, only the new parameters will be added.\n" +
				"Give permission to the save confirmation that appears on the VaM screen. (Click \"Confirm\")\n\n" + 
				"(Do you want to restore all the parameters including the existing ones to their default values? " + 
				"If you want to do so, run \"Load Default\" in the custom UI.)";
			core.worldUi.NotifyToUser(message, 36);
		}

		public void StopOtherPluginsHint(){
			string message = 
			"<b><size=48>Stop other plugins that might conflit:</size></b>\n" +
			"This allows you to temporarily stop other potentially conflicting plug-ins. " +
			"When you click Restart, the other plug-ins will resume their activities again." +
			"(See Hint about AutoStop)\n\n" +
			"<b>Details:</b>\n" +
			"For example, plug-ins that give movement to the head or chest, such as Gaze or Breath, will conflict with this plug-in (EBAT).\n" + 
			"Plugins that may conflict will be listed in Config. You can adjust this by editing the following elements of Config.\n\n" +
			"  <b>File:</b> Custom/Scripts/ExpressionBlushingAndTears_currentSettings.json\n" +
			"  <b>Tag:</b>  Plugins that might Confilict";
			core.worldUi.NotifyToUser(message, 36, width:1200f, height:400f);
		}
		
		public void DoublingColliderHint(){
			string message = 
			"<b><size=48>Doubles the radius of the Collider</size></b>\n" +
			"This setting doubles the radius of the Collider for Labia, Vagina, DeepVagina, and DeeperVagina.\n" +
			"I don't know why, but my Plugin has a bug where the Collider does not work properly in certain pose.\n" + 
			"In order to make Collider work in such situations, this setting extends the radius of Collider to twice the normal radius.\n" + 
			"(The larger the radius, the more responsive the trigger will be. " +
			"However, this side effect may cause her to climax just by rubbing her belly.)";
			
			core.worldUi.NotifyToUser(message, 36, width:1200f, height:400f);
		}
		
		public void AutoStopHint(){
			string message = 
			"<b><size=48>AutoStop OtherPlugins</size></b>\n" +
			"When AutoStop is enabled, other potentially conflicting plug-ins will be stopped " + 
			"when the Ecstasy gauge reaches the second level. " +
			"(See Hint about Stop Other...)\n\n" +
			"This prevents other plug-ins from interfering with head movement and audio, " + 
			"which are the functions of this plugin.\n" +
			"When the Ecstasy gauge goes down, the other plug-ins will resume their activities again.";
			
			core.worldUi.NotifyToUser(message, 36, width:1200f, height:400f);
		}
		
		public void FaceSidewaysHint(){
			string message = 
			"<b><size=48>Head Motion - Face Sideways, Turn Head Back, etc.</size></b>\n" +
			"\"Face Sideways\", \"Turn Head Back\", etc. are functions that allow you to see " +
			"how the PERSON's head and neck move. With this plug-in, when you stimulate a PERSON, " +
			"she will turn her head back or turn her face away from you due to sexual pleasure.\n" + 
			"The probability of head movement occurring can be set from the CustomUI.\n\n" +
			"<b>Custom UI>Expand Head Controller Menu></b>\n" +
			"  - <b>HC Angle:</b> For adjusting the angle of the head movement.\n" +
			"  - <b>HC Event Firing Ratio:</b> For adjusting the ratio of firing event.\n" +
			"  - <b>HC Ratio By Stage:</b> For adjusting the rate at which actions occur.\n";
			
			core.worldUi.NotifyToUser(message, 36, width:1200f, height:400f);
		}
		
		public void BackupPoseHint(){
			string message = 
			"<b><size=48>Backup Pose</size></b>\n" +
			"This is a simple pose backup function. A backup (snap) of the PERSON's pose will be taken " + 
			"after the Plugin is loaded and after the BackupPose button is clicked.\n" +
			"Clicking the Reset button to the left of this button will return to the backed up pose. " + 
			"If you can't get back to the original pose after pressing the button once, " + 
			"you may have to click it several times to get it back.";

			core.worldUi.NotifyToUser(message, 36, width:1200f, height:400f);
		}
		
	}
}